format zx81
;labelusenumeric
;LISTOFF
	MEMAVL	  EQU MEM_16K
	STARTMODE EQU SLOW_MODE
	DFILETYPE EQU COMPRESSED
	include '..\..\SINCL-ZX\ZX81.INC'
;LISTON

//----------------
AUTORUN:
10	 RAND USR (#START)
20	 REM _hide _asm

//----------------
START:
//load the picture vector
	ld	ix,DRAW_MAP

	call	SAVE_BACKGROUND
//endless loop
MAIN_LOOP:
//wait for when the previous picture data was drawn,
//so at the start of the lower border
	ld	hl,FrameCounter
	ld	a,(hl)
.FRAME_WAIT:
	cp	(hl)
	jr	z,.FRAME_WAIT

	call	RESTORE_BACKGROUND

.RIGHT_START:
//if (key == right)
	ld	a,(Keys0)
	bit	2,a
	jp	nz,.RIGHT_DONE
//  if (SpriteXFine == 7)
	ld	a,(SpriteXFine)
	cp	7
	jp	nz,.RIGHT_ELSE
//    if (SpriteX < (MAP_WIDTH - 1 - 2))
	ld	a,(SpriteX)
	cp	MAP_WIDTH - 1 - 2
	jp	nc,.RIGHT_DONE
//      SpriteXFine = 0
	xor	a
	ld	(SpriteXFine),a
//      SpriteX++
	ld	hl,SpriteX
	inc	(hl)
//      SpritePos++
	ld	hl,(SpritePos)
	inc	hl
	ld	(SpritePos),hl
//      if (SpriteX > ((DISPLAY_WIDTH / 2) + 1))
	ld	a,(SpriteX)
	cp	(DISPLAY_WIDTH / 2) + 1
	jp	c,.RIGHT_DONE
//        if (SpriteX < (MAP_WIDTH - (DISPLAY_WIDTH / 2) + 1))
	cp	MAP_WIDTH - (DISPLAY_WIDTH / 2) + 1
	jp	nc,.RIGHT_DONE
//          ScrollXFine = SpriteXFine
	ld	a,(SpriteXFine)
	ld	(ScrollXFine),a
//          MapStart++
	ld	hl,(MapStart)
	inc	hl
	ld	(MapStart),hl
	jp	.RIGHT_DONE
//  else
.RIGHT_ELSE:
//    SpriteXFine++
	ld	hl,SpriteXFine
	inc	(hl)
//    if (SpriteX > ((DISPLAY_WIDTH / 2) + 0))
	ld	a,(SpriteX)
	cp	(DISPLAY_WIDTH / 2) + 0
	jp	c,.RIGHT_DONE
//      if (SpriteX < (MAP_WIDTH - (DISPLAY_WIDTH / 2) + 0))
	cp	MAP_WIDTH - (DISPLAY_WIDTH / 2) + 0
	jp	nc,.RIGHT_DONE
//        ScrollXFine = SpriteXFine
	ld	a,(SpriteXFine)
	ld	(ScrollXFine),a
.RIGHT_DONE:

.LEFT_START:
//if (key == left)
	ld	a,(Keys1)
	bit	4,a
	jp	nz,.LEFT_DONE
//  if (SpriteXFine == 0)
	ld	a,(SpriteXFine)
	cp	0
	jp	nz,.LEFT_ELSE
//    if (SpriteX > 2)
	ld	a,(SpriteX)
	cp	2
	jp	c,.LEFT_DONE
//      SpriteXFine = 7
	ld	a,7
	ld	(SpriteXFine),a
//      SpriteX--
	ld	hl,SpriteX
	dec	(hl)
//      SpritePos--
	ld	hl,(SpritePos)
	dec	hl
	ld	(SpritePos),hl
//      if (SpriteX > ((DISPLAY_WIDTH / 2) + 0))
	ld	a,(SpriteX)
	cp	(DISPLAY_WIDTH / 2) + 0
	jp	c,.LEFT_DONE
//        if (SpriteX < (MAP_WIDTH - (DISPLAY_WIDTH / 2) + 0))
	cp	MAP_WIDTH - (DISPLAY_WIDTH / 2) + 0
	jp	nc,.LEFT_DONE
//          ScrollXFine = SpriteXFine
	ld	a,(SpriteXFine)
	ld	(ScrollXFine),a
//          MapStart--
	ld	hl,(MapStart)
	dec	hl
	ld	(MapStart),hl
	jp	.LEFT_DONE
//  else
.LEFT_ELSE:
//    SpriteXFine--
	ld	hl,SpriteXFine
	dec	(hl)
//    if (SpriteX > ((DISPLAY_WIDTH / 2) + 0))
	ld	a,(SpriteX)
	cp	(DISPLAY_WIDTH / 2) + 0
	jp	c,.LEFT_DONE
//      if (SpriteX < (MAP_WIDTH - (DISPLAY_WIDTH / 2) + 0))
	cp	MAP_WIDTH - (DISPLAY_WIDTH / 2) + 0
	jp	nc,.LEFT_DONE
//        ScrollXFine = SpriteXFine
	ld	a,(SpriteXFine)
	ld	(ScrollXFine),a
.LEFT_DONE:

.UP_START:
//if (key == up)
	ld	a,(Keys0)
	bit	3,a
	jp	nz,.UP_DONE
//  if (SpriteYFine == 0)
	ld	a,(SpriteYFine)
	cp	0
	jp	nz,.UP_ELSE
//    if (SpriteY > 2)
	ld	a,(SpriteY)
	cp	2
	jp	c,.UP_DONE
//      SpriteYFine = 7
	ld	a,7
	ld	(SpriteYFine),a
//      SpriteY--
	ld	hl,SpriteY
	dec	(hl)
//      SpritePos -= MAP_WIDTH
	ld	hl,(SpritePos)
	ld	de,MAP_WIDTH
	xor	a
	sbc	hl,de
	ld	(SpritePos),hl
//      if (SpriteY > ((DISPLAY_HEIGHT / 2) + 0))
	ld	a,(SpriteY)
	cp	(DISPLAY_HEIGHT / 2) + 0
	jp	c,.UP_DONE
//        if (SpriteY < (MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 0))
	cp	MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 0
	jp	nc,.UP_DONE
//          ScrollYFine = SpriteYFine
	ld	a,(SpriteYFine)
	ld	(ScrollYFine),a
//          MapStart -= MAP_WIDTH
	ld	hl,(MapStart)
	ld	de,MAP_WIDTH
	xor	a
	sbc	hl,de
	ld	(MapStart),hl
	jp	.UP_DONE
//  else
.UP_ELSE:
//    SpriteYFine--
	ld	hl,SpriteYFine
	dec	(hl)
//    if (SpriteY > ((DISPLAY_HEIGHT / 2) + 0))
	ld	a,(SpriteY)
	cp	(DISPLAY_HEIGHT / 2) + 0
	jp	c,.UP_DONE
//      if (SpriteY < (MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 0))
	cp	MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 0
	jp	nc,.UP_DONE
//        ScrollYFine = SpriteYFine
	ld	a,(SpriteYFine)
	ld	(ScrollYFine),a
.UP_DONE:

.DOWN_START:
//if (key == down)
	ld	a,(Keys0)
	bit	4,a
	jp	nz,.DOWN_DONE
//  if (SpriteYFine == 7)
	ld	a,(SpriteYFine)
	cp	7
	jp	nz,.DOWN_ELSE
//    if (SpriteY < (MAP_HEIGHT - 1 - 2))
	ld	a,(SpriteY)
	cp	MAP_HEIGHT - 1 - 2
	jp	nc,.DOWN_DONE
//      SpriteYFine = 0
	xor	a
	ld	(SpriteYFine),a
//      SpriteY++
	ld	hl,SpriteY
	inc	(hl)
//      SpritePos += MAP_WIDTH
	ld	hl,(SpritePos)
	ld	de,MAP_WIDTH
	add	hl,de
	ld	(SpritePos),hl
//      if (SpriteY > ((DISPLAY_HEIGHT / 2) + 1))
	ld	a,(SpriteY)
	cp	(DISPLAY_HEIGHT / 2) + 1
	jp	c,.DOWN_DONE
//        if (SpriteY < (MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 1))
	cp	MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 1
	jp	nc,.DOWN_DONE
//          ScrollYFine = SpriteYFine
	ld	a,(SpriteYFine)
	ld	(ScrollYFine),a
//          MapStart += MAP_WIDTH
	ld	hl,(MapStart)
	ld	de,MAP_WIDTH
	add	hl,de
	ld	(MapStart),hl
	jp	.DOWN_DONE
//  else
.DOWN_ELSE:
//    SpriteYFine++
	ld	hl,SpriteYFine
	inc	(hl)
//    if (SpriteY > ((DISPLAY_HEIGHT / 2) + 0))
	ld	a,(SpriteY)
	cp	(DISPLAY_HEIGHT / 2) + 0
	jp	c,.DOWN_DONE
//      if (SpriteY < (MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 0))
	cp	MAP_HEIGHT - (DISPLAY_HEIGHT / 2) + 0
	jp	nc,.DOWN_DONE
//        ScrollYFine = SpriteYFine
	ld	a,(SpriteYFine)
	ld	(ScrollYFine),a
.DOWN_DONE:

	call	SAVE_BACKGROUND
	call	DRAW_SPRITE
//print some status text
	ld	a,(ScrollXFine)
	add	a,$1c
	ld	(STATUS_TEXT + 15),a
	ld	a,(ScrollYFine)
	add	a,$1c
	ld	(STATUS_TEXT + 17),a
	ld	a,(SpriteXFine)
	add	a,$1c
	ld	(STATUS_TEXT + 33),a
	ld	a,(SpriteYFine)
	add	a,$1c
	ld	(STATUS_TEXT + 35),a
	jp	MAIN_LOOP

//----------------
SAVE_BACKGROUND:
	ld	hl,(SpritePos)		//20
	ld	de,SavedBackground	//10
	ldi				//16
	ldi				//16
	ld	bc,MAP_WIDTH - 2	//10
	add	hl,bc			//11
	ldi				//16
	ldi				//16
	ret				//10

//----------------
DRAW_SPRITE:
	ld	hl,SPRITE_DATA		//10
	ld	de,(SpritePos)		//20
	ldi				//16
	ldi				//16
	ld	bc,MAP_WIDTH - 2	//10
	ex	de,hl			//4
	add	hl,bc			//11
	ex	de,hl			//4
	ldi				//16
	ldi				//16
	ret				//10

//----------------
RESTORE_BACKGROUND:
	ld	hl,SavedBackground	//10
	ld	de,(SpritePos)		//20
	ldi				//16
	ldi				//16
	ld	bc,MAP_WIDTH - 2	//10
	ex	de,hl			//4
	add	hl,bc			//11
	ex	de,hl			//4
	ldi				//16
	ldi				//16
	ret				//10

//----------------
//MapStart: where the drawing begins on the map, used to scroll per character
//ScrollXFine: 0-7, resolution is every second pixel
//ScrollYFine: 0-7, resolution is every pixel
DRAW_MAP:
//waste time depending on ScrollXFine
ScrollXFine = $ + 1
	ld	a,0			//7
	and	6			//7
	sla	a			//8
	add	a,.DELAY0 mod 256	//7
	ld	(.DelayTable),a 	//13
	xor	a			//4
.DelayTable = $ + 1
	jp	.DELAY0 		//10
align 16
.DELAY0:
	and	(hl)			//7
	jp	.AFTER_DELAY		//10
.DELAY1:
	dec	hl			//6
	jp	.AFTER_DELAY		//10
.DELAY2:
	ret	c			//5
	jp	.AFTER_DELAY		//10
.DELAY3:
	nop				//4
	jp	.AFTER_DELAY		//10
.AFTER_DELAY:
//waste time
	ret	c			//5
	dec	hl			//6
	ld	b,6			//7
	djnz	$			//13/8
//save shadow registers
	exx				//4
	push	bc			//11
	push	de			//11
	push	hl			//11
//init shadow registers
	ld	hl,(MapStart)		//16
	ld	de,DISPLAY_WIDTH	//10
	add	hl,de			//11
	ld	de,MAP_WIDTH		//10
	ld	c,$c9			//7 $c9 = ret
//change dfile+32 to a ret
	ld	b,(hl)			//7
	ld	(hl),c			//7
	exx				//4
MapStart = $ + 1
	ld	hl,MAP_DATA		//10
	set	7,h			//8
	ld	de,MAP_WIDTH		//10
	ld	b,DISPLAY_HEIGHT_RASTERS//7
//save real stack
	ld	(StackSave),sp		//20
//the line-stack is rotated one step, so a little arithmetic is needed
ScrollYFine = $ + 1
	ld	a,0			//7
	dec	a			//4
	and	7			//7
	sla	a			//8
	ld	(.LineStackStart),a	//13
//init line-stack
.LineStackStart = $ + 1
	ld	sp,LINE_STACK		//10
//draw the picture as specified
	jp	(hl)			//4

//----------------
AFTER_LINE0:
//dec line counter
	dec	b			//4
	jp	z,DRAW_MAP_DONE 	//10/10 previous line was last
//reinit line stack
	ld	sp,LINE_STACK		//10
//waste time
	repeat 9
		nop			//4 * 9 = 36
	end repeat
	ret	z			//5
//draw 1 raster of 32 chars
	jp	(hl)			//4 + (32 * 4) + 10 = 142 (65 left)

//----------------
AFTER_LINE1_6:
//dec line counter
	dec	b			//4
	jp	z,DRAW_MAP_DONE 	//10/10 previous line was last
//waste time
	repeat 11
		nop			//4 * 11 = 44
	end repeat
	xor	0			//7
//draw 1 raster of 32 chars
	jp	(hl)			//4 + (32 * 4) + 10 = 142 (65 left)

//----------------
AFTER_LINE7:
//dec line counter
	dec	b			//4
	jp	z,DRAW_MAP_DONE 	//10/10 previous line was last
//point to next line of text
	add	hl,de			//11
//restore old dfile-data
	exx				//4
	ld	(hl),b			//7
//change dfile+32 to a ret
	add	hl,de			//11
	ld	b,(hl)			//7
	ld	(hl),c			//7
	exx				//4
//draw 1 raster of 32 chars
	jp	(hl)			//4 + (32 * 4) + 10 = 142 (65 left)

//----------------
AFTER_STATUS_LINE:
//dec line counter
	dec	b			//4
	jp	z,STATUS_LINES_DONE	//10/10 previous line was last
//waste time
	ld	a,0			//7
	inc	de			//6
//draw 1 raster of 40 chars
	jp	STATUS_TEXT + $8000	//10

//----------------
DRAW_MAP_DONE:
//restore stack
	ld	sp,(StackSave)		//20
//waste time depending on ScrollXFine
	ld	a,(ScrollXFine) 	//13
	and	6			//7
	sla	a			//8
	add	a,.DELAY0 mod 256	//7
	ld	(.DelayTable),a 	//13
	xor	a			//4
.DelayTable = $ + 1
	jp	.DELAY0 		//10
align 16
.DELAY0:
	nop				//4
	jp	.AFTER_DELAY		//10
.DELAY1:
	ret	c			//5
	jp	.AFTER_DELAY		//10
.DELAY2:
	dec	hl			//6
	jp	.AFTER_DELAY		//10
.DELAY3:
	and	(hl)			//7
	jp	.AFTER_DELAY		//10
.AFTER_DELAY:
//waste time
	repeat 5
		nop			//4 * 5 = 20
	end repeat
//restore dfile+32
	exx				//4
	ld	(hl),b			//7
	exx				//4
//increment FrameCounter
	ld	hl,FrameCounter 	//10
	inc	(hl)			//11
//prepare for bottom margin and VSYNC
	ld	a,BOTTOM_MARGIN 	//7
	neg				//8
	inc	a			//4
	ex	af,af'			//4
	ld	ix,GENERATE_VSYNC	//14
//waste time
	ld	bc,0			//10
//prepare to draw 8 lines of status text
	ld	b,8			//7
//reset LINECNTR in ULA
	in	a,($fe) 		//11
	out	($ff),a 		//11
//waste time
	nop				//4
	nop				//4
//draw the text
	jp	STATUS_TEXT + $8000	//10
STATUS_LINES_DONE:
//restore shadow registers
	exx
	pop	hl			//10
	pop	de			//10
	pop	bc			//10
	exx
//restore registers
	pop	hl			//10
	pop	de			//10
	pop	bc			//10
	pop	af			//10
//NMI on
	out	($fe),a 		//11
//return to application
	ret				//10

//----------------
GENERATE_VSYNC:
//VSync start
	in	a,($fe) 		//11
//read some keys
	ld	bc,$effe		//10 read keys 0-6
	in	a,(c)			//12
	ld	(Keys0),a		//13
	ld	bc,$f7fe		//10read keys 1-5
	in	a,(c)			//12
	ld	(Keys1),a		//13
//waste time, 4 rasters worth of VSync
	ld	b,56			//7
	djnz	$			//13/8
//prepare for top margin
	ld	a,TOP_MARGIN - 7	//7
	ld	hl,ScrollYFine		//10
	sub	(hl)			//7
	neg				//8
	inc	a			//4
//prepare a' for NMI-counter
	ex	af,af'			//4
//reset the row counter at the correct raster to enable fine scrolling Y
	ld	ix,FIX_ROW_COUNTER	//14
//restore registers
	pop	hl			//10
	pop	de			//10
	pop	bc			//10
	pop	af			//10
//NMI on, VSync stop
	out	($fe),a 		//11
//return to application
	ret				//10

//----------------
FIX_ROW_COUNTER:
//waste time
	repeat	5
		and	(hl)		//7 * 5 = 35
	end repeat
//prepare for some more top margin
	ld	a,7			//7
	ld	hl,ScrollYFine		//10
	add	a,(hl)			//7
	neg				//8
	inc	a			//4
//prepare a' for NMI-counter
	ex	af,af'			//4
//prepare to draw the image
	ld	ix,DRAW_MAP		//14
//restore registers
	pop	hl			//10
	pop	de			//10
	pop	bc			//10
//reset LINECNTR in ULA, HSync on
	in	a,($fe) 		//11
//NMI on, HSync off
	out	($fe),a 		//11
	pop	af			//10
//return to application
	ret				//10

//----------------
//It would have been more logical to do have a stack 0-7, but there are
//no cycles left after line7.
//The solution is to rotate the line-stack so that line0 is the last,
//and deal with the arithmetic that entails.
align 256
LINE_STACK:
	dw	AFTER_LINE1_6
	dw	AFTER_LINE1_6
	dw	AFTER_LINE1_6
	dw	AFTER_LINE1_6
	dw	AFTER_LINE1_6
	dw	AFTER_LINE1_6
	dw	AFTER_LINE7
	dw	AFTER_LINE0

//----------------
MAP_WIDTH = MAP_DATA1 - MAP_DATA
MAP_HEIGHT = (MAP_DATA_END - MAP_DATA) / MAP_WIDTH

DISPLAY_WIDTH = 32
DISPLAY_HEIGHT_RASTERS = 96
DISPLAY_HEIGHT = DISPLAY_HEIGHT_RASTERS / 8

TOTAL_RASTERS	= 312			//PAL=312, NTSC=262
VSYNC_RASTERS	= 4
VISIBLE_RASTERS = DISPLAY_HEIGHT_RASTERS + 8
WASTED_RASTERS	= 5
TOTAL_MARGIN	= TOTAL_RASTERS - VISIBLE_RASTERS - VSYNC_RASTERS - WASTED_RASTERS
TOP_MARGIN	= TOTAL_MARGIN / 2
BOTTOM_MARGIN	= TOTAL_MARGIN - TOP_MARGIN

StackSave	dw	0
FrameCounter	db	0
Keys0		db	$ff
Keys1		db	$ff

SPRITE_X_START	equ	DISPLAY_WIDTH / 2
SpriteX 	db	SPRITE_X_START
SpriteXFine	db	0
SPRITE_Y_START	equ	DISPLAY_HEIGHT / 2
SpriteY 	db	SPRITE_Y_START
SpriteYFine	db	0
SpritePos	dw	MAP_DATA + (MAP_WIDTH * SPRITE_Y_START) + SPRITE_X_START
SavedBackground dw	0,0,0,0

SPRITE_DATA	 dbzx	 ''

STATUS_TEXT:
	dbzx	'>>>ScrollFine  ,     SpriteFine  , <<<'
	jp	AFTER_STATUS_LINE
//               0000000000111111111122222222223333333333444444444455555555556666
//               0123456789012345678901234567890123456789012345678901234567890123
MAP_DATA:
	dbzx	''
MAP_DATA1:
	dbzx	'                                                          '
	dbzx	'                                                         '
	dbzx	'                                                        '
	dbzx	'                                                    '
	dbzx	'                                                    '
	dbzx	'                                                    '
	dbzx	'                                                    '
	dbzx	'                                                    '
	dbzx	'                                                     '
	dbzx	'                                                          '
	dbzx	'                                                      '
	dbzx	'                                                      '
	dbzx	'                                                  '
	dbzx	'                                                  '
	dbzx	'̺'
MAP_DATA_END:
//just to make sure nothing is over-counted
	dbzx	''

//----------------
	END	_asm
include '..\..\SINCL-ZX\ZX81DISP.INC'	;include D_FILE and needed memory areas
VARS_ADDR:
	db	80h			;DO NOT REMOVE!!!
WORKSPACE:
assert ($-MEMST)<MEMAVL
// end of program